﻿@page "/seasons"
@using Models.SeasonData
@using Business.Repository.IRepository
@inject ISeasonRepository SeasonRepository
@inject IJSRuntime JsRuntime
@inject Blazored.LocalStorage.ILocalStorageService localStorage
@inject NavigationManager NavigationManager

<div class="row mt-4">
    <div class="col-8">
        <h4 class="card-title text-info">Seasons</h4>
    </div>
    <div class="col-3 offset-1">
        <NavLink href="seasons/create" class="btn btn-primary form-control">Add new season</NavLink>
    </div>
</div>
<div class="row mt-4">
    <div class="col-12">
        <table class="table table-bordered table-hover">
            
            <thead>
                <tr>
                    <th width="45%" class="text-center">Name</th>
                    <th width="22%" class="text-center">Sport</th>
                    <th width="15%" class="text-center">Active</th>
                    <th width="18%">
                        Actions
                    </th>
                </tr>
            </thead>
            <tbody>
                @if (Seasons.Any())
                {
                    @foreach (var season in Seasons)
                    {
                        <tr>
                            <td class="text-center">@season.Name</td>
                            <td class="text-center">@season.Sport.Name</td>
                            @if (season.IsActive)
                            {
                                <td class="text-success font-weight-bold text-center">Active</td>
                            }
                            else
                            {
                                <td class="text-secondary text-center">Non-active</td>
                            }
                            <td>
                                <NavLink href="@($"seasons/edit/{season.Id}")" class="btn btn-primary">Edit</NavLink>
                                <button class="btn btn-danger" @onclick="() => HandleDelete(season.Id)">Delete</button>
                                @if (!season.IsActive)
                                {
                                    <button class="btn btn-success" @onclick="() => HandleSetActive(season)">Set active</button>
                                }
                            </td>
                        </tr>
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5">No records found</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>

<DeleteConfirmation IsParentComponentProcessing="IsProcessing" ConfirmationChanged="ConfirmDelete_Click"></DeleteConfirmation>

@code {
    private IEnumerable<SeasonDTO> Seasons { get; set; } = new List<SeasonDTO>();
    private int? DeleteSeasonId { get; set; } = null;
    private bool IsProcessing { get; set; } = false;

    protected async override Task OnInitializedAsync()
    {
        Seasons = await SeasonRepository.GetAllFromSport(await localStorage.GetItemAsync<int>("sportId"));
    }

    private async Task HandleDelete(int seasonId)
    {
        DeleteSeasonId = seasonId;
        await JsRuntime.InvokeVoidAsync("ShowDeleteConfirmationModal");
    }
    public async Task ConfirmDelete_Click(bool isConfirmed)
    {
        IsProcessing = true;
        if (isConfirmed && DeleteSeasonId != null)
        {
            var result = await SeasonRepository.Delete(DeleteSeasonId.Value);
            if(result == 5)
            {
                await JsRuntime.ToastrError("Cannot delete active season!");
            }
            else if(result == 0)
            {
                await JsRuntime.ToastrError("Season is used and cannot be deleted!");
            }
            else
            {
                await JsRuntime.ToastrSuccess("Season deleted successfully!");
                Seasons = await SeasonRepository.GetAllFromSport(await localStorage.GetItemAsync<int>("sportId"));
            }

        }
        await JsRuntime.InvokeVoidAsync("HideDeleteConfirmationModal");
        IsProcessing = false;
    }
    public async Task HandleSetActive(SeasonDTO season)
    {
        await SeasonRepository.SetActiveSeason(season.Id, await localStorage.GetItemAsync<int>("sportId"));
        await JsRuntime.ToastrSuccess("Season successfully set as active!");
        Seasons = await SeasonRepository.GetAllFromSport(await localStorage.GetItemAsync<int>("sportId"));
        await localStorage.RemoveItemAsync("seasonName");
        await localStorage.SetItemAsync("seasonName", season.Name);
        await localStorage.RemoveItemAsync("seasonId");
        await localStorage.SetItemAsync("seasonId", season.Id);
    }
}
